import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCardLog, ThinkCardLogParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkCardLog(params: ThinkCardLogParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCardLog>>>(
    THINK_API_URL + '/think/think-card-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkCardLog(params?: ThinkCardLogParam) {
  const res = await request.get<ApiResult<ThinkCardLog[]>>(
    THINK_API_URL + '/think/think-card-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkCardLog(data: ThinkCardLog) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkCardLog(data: ThinkCardLog) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkCardLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkCardLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-card-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkCardLog(id: number) {
  const res = await request.get<ApiResult<ThinkCardLog>>(
    THINK_API_URL + '/think/think-card-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
